ADJTIME(2)

NAME
adjtime - correct the time to allow synchronization of the system clock

SYNOPSIS
#include <sys/time.h>
int
adjtime(const struct timeval *delta, struct timeval *olddelta);

DESCRIPTION
adjtime() makes small adjustments to the system time, as returned by gettimeofday(2), advancing or retarding it by the time specified by the timeval delta. If delta is negative, the clock is slowed down by incrementing it more slowly than normal until the correction is complete. If delta is positive, a larger increment than normal is used. The skew used to perform the correction is generally a fraction of one percent. Thus, the time is always a monotonically increasing function. A time correction from an earlier call to adjtime() may not be finished when adjtime() is called again. If delta is null, no adjustment is done. If olddelta is non-null, the structure pointed to will contain, upon return, the number of microseconds still to be corrected from the earlier call. Setting the time with settimeofday(2) will cancel any in-progress time adjustment.

This call may be used by time servers that synchronize the clocks of computers in a local area network. Such time servers would slow down the clocks of some machines and speed up the clocks of others to bring them to the average network time.

Only the superuser may adjust the time using the adjtime() function.

RETURN VALUES

ERRORS
adjtime() will fail if:

[EFAULT]
    Either of the arguments point outside the process's allocated address space.

[EPERM]
    The delta() argument is non-null and the process's effective user ID is not that of the superuser.

SEE ALSO
date(1), adjfreq(2), gettimeofday(2), ntpd(8)

HISTORY
The adjtime() function call appeared in 4.3BSD.

CAVEATS
Other operating systems restrict calling adjtime to the superuser and might not allow requesting the current correction without specifying a new value.